=== debian/changelog ===
mythtv (2:36.0+fixes.20260210.a312d68f-0ubuntu1) resolute; urgency=medium

  * New upstream version.

 -- Mario Limonciello <superm1@debian.org>  Tue, 10 Feb 2026 07:51:37 -0600

mythtv (2:36.0+fixes) noble; urgency=medium

  * Dummy entry to bump version to fixes/36

 -- Roland Ernst <rcrernst@gmail.com>  Thu, 29 Jan 2026 21:08:26 +0100

mythtv (2:36.0~master) noble; urgency=medium

  * Dummy entry to bump version to 36

 -- Roland Ernst <rcrernst@gmail.com>  Thu, 13 Feb 2024 20:15:49 +0100
